# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.93"
name = "foundry-compilers-artifacts-solc"
version = "0.21.0"
authors = ["Foundry Contributors"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Rust bindings for Solc JSON artifacts"
homepage = "https://getfoundry.sh"
readme = "README.md"
license = "MIT OR Apache-2.0"
repository = "https://github.com/foundry-rs/foundry-core"
resolver = "2"

[features]
async = [
    "dep:tokio",
    "dep:futures-util",
]
checksum = ["foundry-compilers-core/hasher"]
rayon = ["dep:rayon"]
walkdir = [
    "rayon",
    "foundry-compilers-core/walkdir",
]

[lib]
name = "foundry_compilers_artifacts_solc"
path = "src/lib.rs"

[dependencies.alloy-json-abi]
version = "1.3.1"
features = ["serde_json"]

[dependencies.alloy-primitives]
version = "1.5.7"
features = [
    "getrandom",
    "rand",
    "map-fxhash",
    "map-foldhash",
]

[dependencies.foundry-compilers-core]
version = "0.21.0"

[dependencies.futures-util]
version = "0.3.32"
optional = true

[dependencies.memchr]
version = "2.7.6"

[dependencies.rayon]
version = "1.11.0"
optional = true

[dependencies.regex]
version = "1.11.3"

[dependencies.semver]
version = "1.0.28"
features = ["serde"]

[dependencies.serde]
version = "1.0.228"
features = [
    "derive",
    "rc",
]

[dependencies.serde_json]
version = "1.0.149"
features = ["arbitrary_precision"]

[dependencies.thiserror]
version = "2.0.18"

[dependencies.tokio]
version = "1.47.1"
features = [
    "rt-multi-thread",
    "fs",
]
optional = true

[dependencies.tracing]
version = "0.1.44"

[dependencies.yansi]
version = "1.0.1"

[dev-dependencies.foundry-compilers-core]
version = "0.21.0"
features = ["test-utils"]

[dev-dependencies.serde_path_to_error]
version = "0.1.20"

[target."cfg(windows)".dependencies.path-slash]
version = "0.2.1"

[lints.clippy]
as_ptr_cast_mut = "allow"
borrow_as_ptr = "warn"
branches_sharing_code = "warn"
clear_with_drain = "warn"
cloned_instead_of_copied = "warn"
cognitive_complexity = "allow"
collection_is_never_read = "warn"
dbg_macro = "warn"
debug_assert_with_mut_call = "allow"
derive_partial_eq_without_eq = "warn"
empty_line_after_doc_comments = "warn"
empty_line_after_outer_attr = "warn"
enum_glob_use = "warn"
equatable_if_let = "warn"
explicit_into_iter_loop = "warn"
explicit_iter_loop = "warn"
fallible_impl_from = "allow"
flat_map_option = "warn"
from_iter_instead_of_collect = "warn"
future_not_send = "allow"
if_not_else = "warn"
if_then_some_else_none = "warn"
implicit_clone = "warn"
imprecise_flops = "warn"
iter_on_empty_collections = "warn"
iter_with_drain = "warn"
iter_without_into_iter = "warn"
large_stack_frames = "warn"
manual_assert = "warn"
manual_clamp = "warn"
manual_string_new = "warn"
missing_const_for_fn = "warn"
mutex_integer = "warn"
naive_bytecount = "warn"
needless_bitwise_bool = "warn"
needless_collect = "allow"
needless_continue = "warn"
needless_for_each = "warn"
non_send_fields_in_send_ty = "allow"
nonstandard_macro_braces = "warn"
option_as_ref_cloned = "warn"
path_buf_push_overwrite = "warn"
read_zero_byte_vec = "warn"
redundant_clone = "warn"
redundant_else = "warn"
redundant_pub_crate = "allow"
result_large_err = "allow"
significant_drop_in_scrutinee = "allow"
significant_drop_tightening = "allow"
single_char_pattern = "warn"
string_lit_as_bytes = "warn"
string_lit_chars_any = "warn"
suboptimal_flops = "warn"
suspicious_operation_groupings = "warn"
too_long_first_doc_paragraph = "allow"
trailing_empty_array = "warn"
trait_duplication_in_bounds = "warn"
transmute_undefined_repr = "warn"
trivial_regex = "warn"
tuple_array_conversions = "warn"
uninhabited_references = "warn"
uninlined_format_args = "warn"
unnecessary_self_imports = "warn"
unnecessary_struct_initialization = "warn"
unnested_or_patterns = "warn"
unused_peekable = "warn"
unused_rounding = "warn"
use_self = "warn"
useless_let_if_seq = "warn"
while_float = "warn"
zero_sized_map_values = "warn"

[lints.rust]
redundant_imports = "warn"
redundant_lifetimes = "warn"
unused_must_use = "deny"

[lints.rust.rust_2018_idioms]
level = "deny"
priority = -1

[lints.rustdoc]
all = "warn"
